//+------------------------------------------------------------------+
//|                                         Williams_ROC_V1.1.mq4    |
//|                                        Copyright  2010, Brooky. |
//|                                                                  |
//| Indicator  to assist CycleSurfer Trading System Concept          |
//|http://www.forex-tsd.com/suggestions-trading-systems              |
//                    25090-my-new-day-trading-system-rate-test.html |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Brooky."
#property link      "http://www.NoLinkYet.com"
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 LightGreen

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1


#property indicator_levelwidth 2
#property indicator_levelstyle 1
#property indicator_level1 0.618
#property indicator_level2 0.328
#property indicator_level3 0
#property indicator_level4 -0.328
#property indicator_level5 -0.618

extern int       wperiod=2000;//Williams % Period Default 2000
extern double       short_level=0.618;//your visual short trigger line
extern double       long_level=-0.618;//your visual long trigger line
extern int       WPI_Array_ma_period=7;//WPI Array smoothing Period
extern int       Price_Array_ma_period=7;//Price Array smoothing Period
extern int       start_bars_back=55;//Base point to start rate of change from
extern int       Price_Multiplier=1000;//Increases Visual Price Movement 1000 for M1//100 for H1 approx
extern bool      show_trigger_lines = false;


double ArrayOnWill[];
double ArrayOnPriceAction[];
double RawPriceMa[];
double RawWillArray[];
double PriceUp[];
double PriceDn[];
double WPRup[];
double WPRdn[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   IndicatorBuffers(8);

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ArrayOnWill);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ArrayOnPriceAction);
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,RawPriceMa);

   SetIndexBuffer(3,PriceUp);

   SetIndexBuffer(4,PriceDn);

   SetIndexBuffer(5,WPRup);

   SetIndexBuffer(6,WPRdn);
  
   //---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Williams_ROC");
   SetIndexLabel(0,"Williams_ROC");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
           
      ObjectDelete("highline");
      ObjectDelete("lowline");
      ObjectDelete("nowline");

 return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   
   ArrayResize(RawWillArray, Bars);   
   ArraySetAsSeries(RawWillArray, true);
   
   ArrayResize(RawPriceMa, Bars);   
   ArraySetAsSeries(RawPriceMa, true);
   
   for(int i = Bars-1; i >= 0; i--)
   { 
   
        int up = 0;
        int dn = 0;
        double ROCadjust;
        
        double ROC =iWPR(NULL,0,wperiod,i) - iWPR(NULL,0,wperiod,i+start_bars_back);
        
          if(ROC>0)
           {
           WPRup[i]=( MathExp( ROC ) - 1 ) / ( MathExp( ROC ) + 1 );
           ROCadjust=WPRup[i];
           }
        if(ROC<0)
           {
           WPRdn[i] =( MathExp( ROC ) - 1 ) / ( MathExp( ROC ) + 1 );
           ROCadjust=WPRdn[i];
           }
        RawWillArray[i]=ROCadjust;
      }  
        
        //----------Price Action Rate of Change
           for(i = Bars-1; i >= 0; i--)
       {
       double ROC_Cadjust;
       double ROC_C = (iClose(NULL,0,i) - iClose(NULL,0,i+start_bars_back));
           if(ROC_C>0)
           {
           PriceUp[i]=( MathExp( ROC_C ) - 1 ) / ( MathExp( ROC_C ) + 1 );
           ROC_Cadjust=PriceUp[i];
           
           }
        if(ROC_C<0)
           {
           PriceDn[i]=( MathExp( ROC_C ) - 1 ) / ( MathExp( ROC_C ) + 1 );
           ROC_Cadjust=PriceDn[i];
           }
        RawPriceMa[i]=ROC_Cadjust*Price_Multiplier;
           }
   

   for( i = Bars-1-wperiod; i >= 0; i--)  
   {    
    ArrayOnWill[i] = iMAOnArray(RawWillArray, 0,WPI_Array_ma_period, 0, 0, i);
    ArrayOnPriceAction[i] =  iMAOnArray(RawPriceMa, 0,Price_Array_ma_period, 0, 0, i);
    
   }
  
 
//---Trigger Visuals
if(show_trigger_lines!=false)
{
   for( i = Bars-1-wperiod; i >= 0; i--)
   {
         
      ObjectDelete("nowline");
      ObjectDelete("highline");
      ObjectDelete("lowline");
      
      
      int windowIndex=WindowFind("Williams_ROC");  
      ObjectCreate("nowline",OBJ_HLINE,windowIndex,0,ArrayOnPriceAction[i]);
      ObjectSet("nowline",OBJPROP_COLOR,Orange);
      ObjectSet("nowline",OBJPROP_WIDTH,3);
      
      windowIndex=WindowFind("Williams_ROC");  
      ObjectCreate("highline",OBJ_HLINE,windowIndex,0,short_level);
      ObjectSet("highline",OBJPROP_COLOR,Crimson);
      ObjectSet("highline",OBJPROP_WIDTH,4);
      
      windowIndex=WindowFind("Williams_ROC");  
      ObjectCreate("lowline",OBJ_HLINE,windowIndex,0,long_level);
      ObjectSet("lowline",OBJPROP_COLOR,Green);
      ObjectSet("lowline",OBJPROP_WIDTH,4);
      WindowRedraw();
      }
      }
   return(0);
  }//----------------------------------------------+